package testutil;

import org.junit.After;
import org.junit.Before;
import table.ExecutionContext;
import table.FunctionTable;

public abstract class SymbolAndFunctionCleaner {

    protected ExecutionContext executionContext;

    public SymbolAndFunctionCleaner() {
        this.executionContext = ExecutionContext.INSTANCE;
    }

    @Before
    public final void setUp() {
        executionContext.clearContext();
        FunctionTable.INSTANCE.resetFunctionTable();
        additionalSetUp();
    }

    @After
    public final void tearDown() {
        executionContext.clearContext();
        FunctionTable.INSTANCE.resetFunctionTable();
        additionalTearDown();
    }

    public void additionalSetUp() {}

    public void additionalTearDown() {}
}
